// MGShapesView.h : interface of the CMGShapesView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MGSHAPESVIEW_H__BCC5CDCC_E584_11D3_A370_C9300D333C73__INCLUDED_)
#define AFX_MGSHAPESVIEW_H__BCC5CDCC_E584_11D3_A370_C9300D333C73__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CMGShapesView : public CView
{
protected: // create from serialization only
	CMGShapesView();
	DECLARE_DYNCREATE(CMGShapesView)

// Attributes
public:
	CMGShapesDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMGShapesView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	void TurnAllOffBut(bool & Dest);
	CShape* m_pShape;
	bool m_FreeHand, m_Ellipse, m_Rectangle, m_Diamond, m_Text;
	
	// For our buffered drawing
	CDC memDC;
	CBitmap memBitmap;
	CBrush m_brBackGround;
	CRect m_Rect;


	virtual ~CMGShapesView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMGShapesView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnEllipse();
	afx_msg void OnUpdateEllipse(CCmdUI* pCmdUI);
	afx_msg void OnFreehand();
	afx_msg void OnUpdateFreehand(CCmdUI* pCmdUI);
	afx_msg void OnRectangle();
	afx_msg void OnUpdateRectangle(CCmdUI* pCmdUI);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDiamond();
	afx_msg void OnUpdateDiamond(CCmdUI* pCmdUI);
	afx_msg void OnEditUndo();
	afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
	afx_msg void OnText();
	afx_msg void OnUpdateText(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MGShapesView.cpp
inline CMGShapesDoc* CMGShapesView::GetDocument()
   { return (CMGShapesDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MGSHAPESVIEW_H__BCC5CDCC_E584_11D3_A370_C9300D333C73__INCLUDED_)
