// ShapeText.cpp: implementation of the CShapeText class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MGShapes.h"
#include "ShapeText.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL( CShapeText, CShape, 1 )

CShapeText::CShapeText()
{

}

CShapeText::~CShapeText()
{

}
void CShapeText::OnDraw(CDC *pDC)
{
	// MG: Text drawing: If we don't have text yet, we draw a rectangle.
	// otherwise we create a font and draw the text
	if( m_Points.GetSize() == 2 )
	{
		CRect Tmp( m_Points[0], m_Points[1] );
		if( m_Text.GetLength() )
		{
			CFont FntTmp;
			CSize Size;
			CFont* pOld=0;
			int Width=Tmp.Width();

			// MG: This loop is done to make the font fit nicely within the width of the rectangle,
			// Because width is given as the average character width.
			do {
			FntTmp.CreateFont( Tmp.Height(), Tmp.Width()/m_Text.GetLength(), 0, 0, FW_NORMAL, 0, 0, 0, 
				DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
				FF_DONTCARE|DEFAULT_PITCH, "New Courier" );
				if( pOld )
					pDC->SelectObject( &FntTmp );
				else
					pOld = pDC->SelectObject( &FntTmp );
				Size = pDC->GetTextExtent( m_Text );
				if( Size.cx > Width )
				{
					Tmp.right--;
					FntTmp.DeleteObject();
				}
			} while( Size.cx > Width );
			pDC->TextOut( Tmp.left, Tmp.top, m_Text );
			pDC->SelectObject( pOld );
		}
		else
			pDC->Rectangle( &Tmp );
	}

}

void CShapeText::MidPoint(CPoint &Point)
{
	MaxTwo( Point ); 
}

void CShapeText::EndPoint(CPoint &Point)
{
	// MG: On Endpoint, proimpt user for the text
	MaxTwo( Point );
	CInputDlg X( "Text:", m_Text );
	X.DoModal();
}

void CShapeText::Serialize(CArchive &ar)
{
	// MG: Serialize points, and out text
	CShape::Serialize( ar );
	if( ar.IsStoring() )
		ar << m_Text;
	else
		ar >> m_Text;
}
